unit ex_memory;

interface

function malloc( size: Integer ): Pointer; cdecl;
procedure free( p: Pointer ); cdecl;
function realloc( p: Pointer; size: Integer ): Pointer; cdecl;
procedure _memset( p: pointer; value: Byte; Size: Integer ); cdecl;
function _memcpy( dest, src: Pointer; count: Integer ): Pointer; cdecl;
function memmove( dest, src: Pointer; count: Integer ): Pointer; cdecl;

var
    __imp__malloc: Pointer = @ malloc;
    __imp__free: Pointer = @ free;
    __imp__realloc: Pointer = @ realloc;
    __imp__memmove: Pointer = @ memmove;

implementation

function malloc( size: Integer ): Pointer; cdecl;
begin
  GetMem( Result, size );
end;

procedure free( p: Pointer ); cdecl;
begin
  FreeMem( p );
end;

function realloc( p: Pointer; size: Integer ): Pointer; cdecl;
begin
  Result := p;
  ReallocMem( Result, size );
end;

procedure _memset( p: pointer; value: Byte; Size: Integer ); cdecl;
begin
  FillChar( p^, Size, Value );
end;

function _memcpy( dest, src: Pointer; count: Integer ): Pointer; cdecl;
begin
  move( src^, dest^, count );
  Result := dest;
end;

function memmove( dest, src: Pointer; count: Integer ): Pointer; cdecl;
begin
  move( src^, dest^, count );
  Result := dest;
end;

end.
